Index: /main/trunk/greenstone2/bin/script/gti.pl
===================================================================
--- /main/trunk/greenstone2/bin/script/gti.pl	(revision 24626)
+++ /main/trunk/greenstone2/bin/script/gti.pl	(revision 24627)
@@ -1002,48 +979,48 @@
 		$year2 += 2000;
     }
-
+	
     # Compare year
     if ($year1 > $year2) {
-	return 1;
+		return 1;
     }
     elsif ($year1 == $year2) {
-	# Year is the same, so compare month
-	if ($months{$date1parts[1]} > $months{$date2parts[1]}) {
-	    return 1;
-	}
-	elsif ($months{$date1parts[1]} == $months{$date2parts[1]}) {
-	    # Month is the same, so compare day
-	    if ($date1parts[0] > $date2parts[0]) {
+		# Year is the same, so compare month
+		if ($months{$date1parts[1]} > $months{$date2parts[1]}) {
+			return 1;
+		}
+		elsif ($months{$date1parts[1]} == $months{$date2parts[1]}) {
+			# Month is the same, so compare day
+			if ($date1parts[0] > $date2parts[0]) {
+				return 1;
+			}
+		}
+    }
+	
+    return 0;
+}
+
+sub is_date_after
+{
+    my ($date1, $date2) = @_;
+    
+    if(!defined $date1) {
 		return 1;
-	    }
-	}
-    }
-
-    return 0;
-}
-
-sub is_date_after
-{
-    my ($date1, $date2) = @_;
-    
-    if(!defined $date1) {
-      return 1;
     }
     if(!defined $date2) {
-      return 0;
+		return 0;
     }
     
     # 16-Aug-2006
     if($date1=~ /(\d+?)-(\S\S\S)-(\d\d\d\d)/){
-       my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
-		  "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
-       $date1=$3 . "-" . $months{$2} . "-" . $1;
-       # print "** converted date1: $date1\n";
+		my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
+		"Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
+		$date1=$3 . "-" . $months{$2} . "-" . $1;
+		# print "** converted date1: $date1\n";
     }
     if($date2=~ /(\d+?)-(\S\S\S)-(\d\d\d\d)/){
-       my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
-		  "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
-       $date2=$3 . "-" . $months{$2} . "-" . $1;
-       # print "** converted date2: $date2\n";
+		my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
+		"Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
+		$date2=$3 . "-" . $months{$2} . "-" . $1;
+		# print "** converted date2: $date2\n";
     }
     
@@ -1055,17 +1032,17 @@
     # Compare year
     if ($date1parts[0] > $date2parts[0]) {
-	return 1;
+		return 1;
     }
     elsif ($date1parts[0] == $date2parts[0]) {
-	# Year is the same, so compare month
-	if ($date1parts[1] > $date2parts[1]) {
-	    return 1;
-	}
-	elsif ($date1parts[1] == $date2parts[1]) {
-	    # Month is the same, so compare day
-	    if ($date1parts[2] > $date2parts[2]) {
-		return 1;
-	    }
-	}
+		# Year is the same, so compare month
+		if ($date1parts[1] > $date2parts[1]) {
+			return 1;
+		}
+		elsif ($date1parts[1] == $date2parts[1]) {
+			# Month is the same, so compare day
+			if ($date1parts[2] > $date2parts[2]) {
+				return 1;
+			}
+		}
     }    
     
@@ -1077,5 +1054,5 @@
 {
     my ($translation_file_key, $target_file, $total_num_chunks, $target_files_keys_requiring_translation, $target_files_keys_requiring_updating, $num_chunks_to_return, $source_files_key_to_text_mapping, $target_files_key_to_text_mapping, $source_files_key_to_last_update_date_mapping, $target_files_key_to_last_update_date_mapping) = @_;
-
+	
     # Form an XML response to the command
     my $xml_response = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
@@ -1087,60 +1064,60 @@
 	. " num_chunks_requiring_translation=\"" . scalar(@$target_files_keys_requiring_translation) . "\""
 	. " num_chunks_requiring_updating=\"" . scalar(@$target_files_keys_requiring_updating) . "\"\/>\n";
-
+	
     # Do chunks requiring translation first
     if ($num_chunks_to_return > scalar(@$target_files_keys_requiring_translation)) {
-	$xml_response .= "  <ChunksRequiringTranslation size=\"" . scalar(@$target_files_keys_requiring_translation) . "\">\n";
+		$xml_response .= "  <ChunksRequiringTranslation size=\"" . scalar(@$target_files_keys_requiring_translation) . "\">\n";
     }
     else {
-	$xml_response .= "  <ChunksRequiringTranslation size=\"" . $num_chunks_to_return . "\">\n";
-    }
-
+		$xml_response .= "  <ChunksRequiringTranslation size=\"" . $num_chunks_to_return . "\">\n";
+    }
+	
     my @sorted_chunk_keys = sort (@$target_files_keys_requiring_translation);
     foreach my $chunk_key (@sorted_chunk_keys) {
-	last if ($num_chunks_to_return == 0);
-
-	my $source_file_chunk_date = $source_files_key_to_last_update_date_mapping->{$chunk_key} || "";
-	my $source_file_chunk_text = &make_text_xml_safe($source_files_key_to_text_mapping->{$chunk_key});	
-	
-	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
-	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";	
-	$xml_response .= "      <TargetFileText></TargetFileText>\n";
-	$xml_response .= "    </Chunk>\n";
-
-	$num_chunks_to_return--;
-    }
-
+		last if ($num_chunks_to_return == 0);
+		
+		my $source_file_chunk_date = $source_files_key_to_last_update_date_mapping->{$chunk_key} || "";
+		my $source_file_chunk_text = &make_text_xml_safe($source_files_key_to_text_mapping->{$chunk_key});	
+		
+		$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
+		$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";	
+		$xml_response .= "      <TargetFileText></TargetFileText>\n";
+		$xml_response .= "    </Chunk>\n";
+		
+		$num_chunks_to_return--;
+    }
+	
     $xml_response .= "  </ChunksRequiringTranslation>\n";
-
+	
     # Then do chunks requiring updating
     if ($num_chunks_to_return > scalar(@$target_files_keys_requiring_updating)) {
-	$xml_response .= "  <ChunksRequiringUpdating size=\"" . scalar(@$target_files_keys_requiring_updating) . "\">\n";
+		$xml_response .= "  <ChunksRequiringUpdating size=\"" . scalar(@$target_files_keys_requiring_updating) . "\">\n";
     }
     else {
-	$xml_response .= "  <ChunksRequiringUpdating size=\"" . $num_chunks_to_return . "\">\n";
-    }
-        
+		$xml_response .= "  <ChunksRequiringUpdating size=\"" . $num_chunks_to_return . "\">\n";
+    }
+	
     # foreach my $chunk_key (@target_file_keys_requiring_updating) {
     @sorted_chunk_keys = sort (@$target_files_keys_requiring_updating);
     foreach my $chunk_key (@sorted_chunk_keys) {
-	last if ($num_chunks_to_return == 0);
-
-	my $source_file_chunk_date = $source_files_key_to_last_update_date_mapping->{$chunk_key} || "";
-	my $source_file_chunk_text = &make_text_xml_safe($source_files_key_to_text_mapping->{$chunk_key});
-	my $target_file_chunk_date = $target_files_key_to_last_update_date_mapping->{$chunk_key} || "";
-	my $target_file_chunk_text = &make_text_xml_safe($target_files_key_to_text_mapping->{$chunk_key});
-
-	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";	
-	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
-	$xml_response .= "      <TargetFileText date=\"$target_file_chunk_date\">$target_file_chunk_text</TargetFileText>\n";
-	$xml_response .= "    </Chunk>\n";
-
-	$num_chunks_to_return--;
-    }
-
+		last if ($num_chunks_to_return == 0);
+		
+		my $source_file_chunk_date = $source_files_key_to_last_update_date_mapping->{$chunk_key} || "";
+		my $source_file_chunk_text = &make_text_xml_safe($source_files_key_to_text_mapping->{$chunk_key});
+		my $target_file_chunk_date = $target_files_key_to_last_update_date_mapping->{$chunk_key} || "";
+		my $target_file_chunk_text = &make_text_xml_safe($target_files_key_to_text_mapping->{$chunk_key});
+		
+		$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";	
+		$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
+		$xml_response .= "      <TargetFileText date=\"$target_file_chunk_date\">$target_file_chunk_text</TargetFileText>\n";
+		$xml_response .= "    </Chunk>\n";
+		
+		$num_chunks_to_return--;
+    }
+	
     $xml_response .= "  </ChunksRequiringUpdating>\n";
-
+	
     $xml_response .= "</GTIResponse>\n";
-
+	
     return $xml_response;
 }
@@ -1150,5 +1127,5 @@
 {
     my ($translation_file_key, $target_file, $source_file_key_to_text_mapping, $target_file_key_to_text_mapping, $source_file_key_to_last_update_date_mapping, $target_file_key_to_last_update_date_mapping) = @_;
-
+	
     # Form an XML response to the command
     my $xml_response = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
@@ -1160,22 +1137,22 @@
     # Do all the chunks
     $xml_response .= "  <Chunks size=\"" . scalar(keys(%$source_file_key_to_text_mapping)) . "\">\n";
-
+	
     my @sorted_chunk_keys = sort (keys(%$source_file_key_to_text_mapping));
     foreach my $chunk_key (@sorted_chunk_keys) {
-	my $source_file_chunk_date = $source_file_key_to_last_update_date_mapping->{$chunk_key} || "";
-	my $source_file_chunk_text = &make_text_xml_safe($source_file_key_to_text_mapping->{$chunk_key});
-
-	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
-	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
-	if (defined($target_file_key_to_text_mapping->{$chunk_key})) {
-	    my $target_file_chunk_date = $target_file_key_to_last_update_date_mapping->{$chunk_key} || "";
-	    my $target_file_chunk_text = &make_text_xml_safe($target_file_key_to_text_mapping->{$chunk_key});
-	    $xml_response .= "      <TargetFileText date=\"$target_file_chunk_date\">$target_file_chunk_text</TargetFileText>\n";
-	}
-	else {
-	    $xml_response .= "      <TargetFileText></TargetFileText>\n";
-	}
-
-	$xml_response .= "    </Chunk>\n";
+		my $source_file_chunk_date = $source_file_key_to_last_update_date_mapping->{$chunk_key} || "";
+		my $source_file_chunk_text = &make_text_xml_safe($source_file_key_to_text_mapping->{$chunk_key});
+		
+		$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
+		$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
+		if (defined($target_file_key_to_text_mapping->{$chunk_key})) {
+			my $target_file_chunk_date = $target_file_key_to_last_update_date_mapping->{$chunk_key} || "";
+			my $target_file_chunk_text = &make_text_xml_safe($target_file_key_to_text_mapping->{$chunk_key});
+			$xml_response .= "      <TargetFileText date=\"$target_file_chunk_date\">$target_file_chunk_text</TargetFileText>\n";
+		}
+		else {
+			$xml_response .= "      <TargetFileText></TargetFileText>\n";
+		}
+		
+		$xml_response .= "    </Chunk>\n";
     }
     $xml_response .= "  </Chunks>\n";
@@ -1193,33 +1170,33 @@
 {
     my (@file_lines) = @_;
-
+	
     my $macro_package;
     my %chunk_key_to_line_mapping = ();
     # Process the contents of the file, line by line
     for (my $i = 0; $i < scalar(@file_lines); $i++) {
-	my $line = $file_lines[$i];
-	$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
-
-	# Check if a new package is being defined
-	if ($line =~ m/^package\s+(.+)/) {
-	    $macro_package = $1;
-	}
-
-	# Line contains a macro name
-	elsif ($line =~ m/^(_\w+_)/) {
-	    my $macro_key = $1;
-	    $line =~ s/\s*([^\\]\#[^\}]+)?$//;  # Remove any comments and nasty whitespace
-
-	    # While there is still text of the macro to go...
-	    my $startline = $i;
-	    while ($line !~ /\}$/) {
-		$i++;
-		if ($i == scalar(@file_lines)) {
-		    &throw_fatal_error("Could not find end of macro $macro_key.");
-		}
-		$line = $file_lines[$i];
-		$line =~ s/\s*([^\\]\#[^\}]+)?$//;  # Remove any comments and nasty whitespace
-	    }
-
+		my $line = $file_lines[$i];
+		$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
+		
+		# Check if a new package is being defined
+		if ($line =~ m/^package\s+(.+)/) {
+			$macro_package = $1;
+		}
+		
+		# Line contains a macro name
+		elsif ($line =~ m/^(_\w+_)/) {
+			my $macro_key = $1;
+			$line =~ s/\s*([^\\]\#[^\}]+)?$//;  # Remove any comments and nasty whitespace
+			
+			# While there is still text of the macro to go...
+			my $startline = $i;
+			while ($line !~ /\}$/) {
+				$i++;
+				if ($i == scalar(@file_lines)) {
+					&throw_fatal_error("Could not find end of macro $macro_key.");
+				}
+				$line = $file_lines[$i];
+				$line =~ s/\s*([^\\]\#[^\}]+)?$//;  # Remove any comments and nasty whitespace
+			}
+		
 	    # The chunk key consists of the package name and the macro key
 	    my $chunk_key = $macro_package . "." . $macro_key;
@@ -1227,15 +1204,15 @@
 	    $chunk_key_to_line_mapping{$chunk_key} = $startline . "-" . $i;
 	}
-
+	
 	# Icon: line in format ## "image text" ## image_type ## macro_name ##
 	elsif ($line =~ m/^\#\# .* \#\# .* \#\# (.*) \#\#/) {
-	    # The chunk key consists of package name and macro key
-	    my $chunk_key = $macro_package . "." . $1;
-	    # Map from chunk key to line
-	    $chunk_key_to_line_mapping{$chunk_key} = $i . "-" . $i;
-	}
-    }
-
-    return %chunk_key_to_line_mapping;
+	# The chunk key consists of package name and macro key
+	my $chunk_key = $macro_package . "." . $1;
+	# Map from chunk key to line
+	$chunk_key_to_line_mapping{$chunk_key} = $i . "-" . $i;
+}
+}
+
+return %chunk_key_to_line_mapping;
 }
 
@@ -1244,29 +1221,29 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Is this an icon macro??
     if ($chunk_text =~ /^\#\# (.*)/) {
-	# Extract image macro text
-	$chunk_text =~ /^\#\#\s+([^\#]+)\s+\#\#/;
-	$chunk_text = $1;
-
+		# Extract image macro text
+		$chunk_text =~ /^\#\#\s+([^\#]+)\s+\#\#/;
+		$chunk_text = $1;
+	
 	# Remove enclosing quotes
 	$chunk_text =~ s/^\"//;
 	$chunk_text =~ s/\"$//;
-    }
-
-    # No, so it must be a text macro
-    else {
+}
+
+# No, so it must be a text macro
+else {
 	# Remove macro key
 	$chunk_text =~ s/^_([^_]+)_(\s*)//;
-
+	
 	# Remove language specifier
 	$chunk_text =~ s/^\[l=.*\](\s*)//;
-
+	
 	# Remove braces enclosing text
 	$chunk_text =~ s/^{(\s*)((.|\n)*)}(\s*)(\#.+\s*)?/$2/;
-    }
-
-    return $chunk_text;
+}
+
+return $chunk_text;
 }
 
@@ -1275,11 +1252,11 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Check for an "Updated DD-MMM-YYYY" comment at the end of the chunk
     if ($chunk_text =~ /\#\s+(Updated\s+\d?\d-\D\D\D-\d\d\d\d.*)\s*$/i) {
-	return $1;
-    }
-
-    return undef;
+		return $1;
+}
+
+return undef;
 }
 
@@ -1288,10 +1265,10 @@
 {
     my ($chunk_key) = @_;
-
+	
     # The _httpiconX_, _widthX_ and _heightX_ image macros are automatically translated
     if ($chunk_key =~ /\._(httpicon|width|height)/) {
-	return 1;
-    }
-
+		return 1;
+    }
+	
     return 0;
 }
@@ -1309,78 +1286,78 @@
     my $target_file_key_to_gti_comment_mapping = shift(@_);
     my $target_language_code = shift(@_);
-
+	
     # Build a mapping from source file line to chunk key
     my %source_file_key_to_line_mapping = &build_key_to_line_mapping_for_macrofile(@source_file_lines);
     my %source_file_line_to_key_mapping = ();
     foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
+		$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
     }
     my @source_file_line_keys = (sort sort_by_line (keys(%source_file_line_to_key_mapping)));
     my $source_file_line_number = 0;
-
+	
     # Build a mapping from target file line to chunk key
     my %target_file_key_to_line_mapping = &build_key_to_line_mapping_for_macrofile(@target_file_lines);
     my %target_file_line_to_key_mapping = ();
     foreach my $chunk_key (keys(%target_file_key_to_line_mapping)) {
-	$target_file_line_to_key_mapping{$target_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
+		$target_file_line_to_key_mapping{$target_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
     }
     my @target_file_line_keys = (sort sort_by_line (keys(%target_file_line_to_key_mapping)));
-
+	
     # Write the new target file
     my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
     if (!open(TARGET_FILE, ">$target_file_path")) {
-	&throw_fatal_error("Could not write target file $target_file_path.");
-    }
-
+		&throw_fatal_error("Could not write target file $target_file_path.");
+    }
+	
     # Use the header from the target file, to keep language and author information
     if (scalar(@target_file_line_keys) > 0) {
-	my $target_file_line_number = 0;
- 	my $target_file_chunk_starting_line_number = (split(/-/, $target_file_line_keys[0]))[0];
- 	while ($target_file_line_number < $target_file_chunk_starting_line_number) {
-	    my $target_file_line = $target_file_lines[$target_file_line_number];
-	    last if ($target_file_line =~ /^\# -- Missing translation: /);  # We don't want to get into the macros
- 	    print TARGET_FILE $target_file_line;
- 	    $target_file_line_number++;
- 	}
-
-	$source_file_line_number = (split(/-/, $source_file_line_keys[0]))[0];
-    }
-
+		my $target_file_line_number = 0;
+		my $target_file_chunk_starting_line_number = (split(/-/, $target_file_line_keys[0]))[0];
+		while ($target_file_line_number < $target_file_chunk_starting_line_number) {
+			my $target_file_line = $target_file_lines[$target_file_line_number];
+			last if ($target_file_line =~ /^\# -- Missing translation: /);  # We don't want to get into the macros
+				print TARGET_FILE $target_file_line;
+			$target_file_line_number++;
+		}
+		
+		$source_file_line_number = (split(/-/, $source_file_line_keys[0]))[0];
+    }
+	
     # Model the new target file on the source file, with the target file translations
     foreach my $line_key (@source_file_line_keys) {
- 	# Fill in the gaps before this chunk starts
- 	my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
- 	my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
- 	while ($source_file_line_number < $source_file_chunk_starting_line_number) {
- 	    print TARGET_FILE $source_file_lines[$source_file_line_number];
- 	    $source_file_line_number++;
- 	}
- 	$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
-
-	my $chunk_key = $source_file_line_to_key_mapping{$line_key};
-	my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
-	my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
-
-	my $macrofile_key = $chunk_key;
-	$macrofile_key =~ s/^(.+?)\.//;
-
-	# If no translation exists for this chunk, show this, and move on
-	if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
-	    print TARGET_FILE "# -- Missing translation: $macrofile_key\n";
-	    next;
-	}
-
- 	# Grab the source chunk text
- 	my $source_file_chunk = $source_file_lines[$source_file_chunk_starting_line_number];
- 	for (my $l = ($source_file_chunk_starting_line_number + 1); $l <= $source_file_chunk_finishing_line_number; $l++) {
- 	    $source_file_chunk .= $source_file_lines[$l];
- 	}
-
- 	# Is this an icon macro??
- 	if ($source_file_chunk =~ /^\#\# (.*)/) {
- 	    # Escape any newline and question mark characters so the source text is replaced correctly
- 	    $source_file_chunk_text =~ s/\\/\\\\/g;
+		# Fill in the gaps before this chunk starts
+		my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
+		my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
+		while ($source_file_line_number < $source_file_chunk_starting_line_number) {
+			print TARGET_FILE $source_file_lines[$source_file_line_number];
+			$source_file_line_number++;
+		}
+		$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
+		
+		my $chunk_key = $source_file_line_to_key_mapping{$line_key};
+		my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
+		my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
+		
+		my $macrofile_key = $chunk_key;
+		$macrofile_key =~ s/^(.+?)\.//;
+		
+		# If no translation exists for this chunk, show this, and move on
+		if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
+			print TARGET_FILE "# -- Missing translation: $macrofile_key\n";
+			next;
+		}
+		
+		# Grab the source chunk text
+		my $source_file_chunk = $source_file_lines[$source_file_chunk_starting_line_number];
+		for (my $l = ($source_file_chunk_starting_line_number + 1); $l <= $source_file_chunk_finishing_line_number; $l++) {
+			$source_file_chunk .= $source_file_lines[$l];
+		}
+		
+		# Is this an icon macro??
+		if ($source_file_chunk =~ /^\#\# (.*)/) {
+			# Escape any newline and question mark characters so the source text is replaced correctly
+			$source_file_chunk_text =~ s/\\/\\\\/g;
 	    $source_file_chunk_text =~ s/\?/\\\?/g;
-
+		
 	    # Build the new target chunk from the source chunk
 	    my $target_file_chunk = $source_file_chunk;
@@ -1389,10 +1366,10 @@
 	    print TARGET_FILE "$target_file_chunk";
  	}
-
+	
  	# No, it is just a normal text macro
  	else {
  	    print TARGET_FILE "$macrofile_key [l=$target_language_code] {$target_file_chunk_text}";
  	}
-
+	
 	# Add the "updated" comment, if one exists
 	if ($target_file_key_to_gti_comment_mapping->{$chunk_key}) {
@@ -1400,7 +1377,7 @@
 	}
 	print TARGET_FILE "\n";
-    }
-
-    close(TARGET_FILE);
+}
+
+close(TARGET_FILE);
 }
 
@@ -1418,19 +1395,19 @@
 {
     my (@file_lines) = @_;
-
+	
     my %chunk_key_to_line_mapping = ();
     for (my $i = 0; $i < scalar(@file_lines); $i++) {
-	my $line = $file_lines[$i];
-	$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
-
-	# Line contains a dictionary string
-	if ($line =~ /^(\S+?)[:|=](.*)$/) {
-	    my $chunk_key = $1;
-
-	    # Map from chunk key to line
-	    $chunk_key_to_line_mapping{$chunk_key} = $i . "-" . $i;
-	}
-    }
-
+		my $line = $file_lines[$i];
+		$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
+		
+		# Line contains a dictionary string
+		if ($line =~ /^(\S+?)[:|=](.*)$/) {
+			my $chunk_key = $1;
+			
+			# Map from chunk key to line
+			$chunk_key_to_line_mapping{$chunk_key} = $i . "-" . $i;
+		}
+    }
+	
     return %chunk_key_to_line_mapping;
 }
@@ -1440,10 +1417,10 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Simple: just remove string key
     $chunk_text =~ s/^(\S+?)[:|=](\s*)//;
     $chunk_text =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
     $chunk_text =~ s/(\s*)\#\s+Updated\s+(\d?\d-\D\D\D-\d\d\d\d.*)\s*$//i;
-
+	
     return $chunk_text;
 }
@@ -1453,11 +1430,11 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Check for an "Updated DD-MMM-YYYY" comment at the end of the chunk
     if ($chunk_text =~ /\#\s+(Updated\s+\d?\d-\D\D\D-\d\d\d\d.*)\s*$/i) {
-	return $1;
-    }
-
-    return undef;
+		return $1;
+}
+
+return undef;
 }
 
@@ -1480,47 +1457,47 @@
     my $target_file_key_to_gti_comment_mapping = shift(@_);
     my $target_language_code = shift(@_);  # Not used
-
+	
     # Build a mapping from chunk key to source file line, and from source file line to chunk key
     my %source_file_key_to_line_mapping = &build_key_to_line_mapping_for_resource_bundle(@source_file_lines);
     my %source_file_line_to_key_mapping = ();
     foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
-    }
-
+		$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
+    }
+	
     # Write the new target file
     my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
     if (!open(TARGET_FILE, ">$target_file_path")) {
-	&throw_fatal_error("Could not write target file $target_file_path.");
-    }
-
+		&throw_fatal_error("Could not write target file $target_file_path.");
+    }
+	
     # Model the new target file on the source file, with the target file translations
     my $source_file_line_number = 0;
     foreach my $line_key (sort sort_by_line (keys(%source_file_line_to_key_mapping))) {
- 	# Fill in the gaps before this chunk starts
- 	my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
- 	my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
- 	while ($source_file_line_number < $source_file_chunk_starting_line_number) {
- 	    print TARGET_FILE $source_file_lines[$source_file_line_number];
- 	    $source_file_line_number++;
- 	}
- 	$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
-
-	my $chunk_key = $source_file_line_to_key_mapping{$line_key};
-	my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
-	my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
-
-	# If no translation exists for this chunk, show this, and move on
-	if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
-	    print TARGET_FILE "# -- Missing translation: $chunk_key\n";
-	    next;
-	}
-
-	print TARGET_FILE "$chunk_key:$target_file_chunk_text";
-	if ($target_file_key_to_gti_comment_mapping->{$chunk_key}) {
-	    print TARGET_FILE "  # " . $target_file_key_to_gti_comment_mapping->{$chunk_key};
-	}
-	print TARGET_FILE "\n";
-    }
-
+		# Fill in the gaps before this chunk starts
+		my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
+		my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
+		while ($source_file_line_number < $source_file_chunk_starting_line_number) {
+			print TARGET_FILE $source_file_lines[$source_file_line_number];
+			$source_file_line_number++;
+		}
+		$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
+		
+		my $chunk_key = $source_file_line_to_key_mapping{$line_key};
+		my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
+		my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
+		
+		# If no translation exists for this chunk, show this, and move on
+		if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
+			print TARGET_FILE "# -- Missing translation: $chunk_key\n";
+			next;
+		}
+		
+		print TARGET_FILE "$chunk_key:$target_file_chunk_text";
+		if ($target_file_key_to_gti_comment_mapping->{$chunk_key}) {
+			print TARGET_FILE "  # " . $target_file_key_to_gti_comment_mapping->{$chunk_key};
+		}
+		print TARGET_FILE "\n";
+    }
+	
     close(TARGET_FILE);
 }
@@ -1533,38 +1510,38 @@
 {
     my (@file_lines) = @_;
-
+	
     my %chunk_key_to_line_mapping = ();
     for (my $i = 0; $i < scalar(@file_lines); $i++) {
-	my $line = $file_lines[$i];
-	$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
-
-	# Line contains a string to translate
-	if ($line =~ /^\s*<Text id=\"(.*?)\">/) {
-	    my $chunk_key = $1;
-	    $line =~ s/\s*$//;  # Remove any nasty whitespace
-	    $line =~ s/<Updated date=\"\d?\d-\D\D\D-\d\d\d\d.*\"\/>$//;
-
-	    # While there is still text of the string to go...
-	    my $startline = $i;
-	    while ($line !~ /<\/Text>$/) {
-		$i++;
-		if ($i == scalar(@file_lines)) {
-		    &throw_fatal_error("Could not find end of string $chunk_key.");
-		}
-		$line = $file_lines[$i];
-		$line =~ s/\s*$//;  # Remove any nasty whitespace
-		$line =~ s/<Updated date=\"\d?\d-\D\D\D-\d\d\d\d.*\"\/>$//;
-	    }
-
-	    # Map from chunk key to line
-	    if (!defined($chunk_key_to_line_mapping{$chunk_key})) {
-		$chunk_key_to_line_mapping{$chunk_key} = $startline . "-" . $i;
-	    }
-	    else {
-		&throw_fatal_error("Duplicate key $chunk_key.");
-	    }
-	}
-    }
-
+		my $line = $file_lines[$i];
+		$line =~ s/(\s*)$//;  # Remove any nasty whitespace, carriage returns etc.
+		
+		# Line contains a string to translate
+		if ($line =~ /^\s*<Text id=\"(.*?)\">/) {
+			my $chunk_key = $1;
+			$line =~ s/\s*$//;  # Remove any nasty whitespace
+			$line =~ s/<Updated date=\"\d?\d-\D\D\D-\d\d\d\d.*\"\/>$//;
+			
+			# While there is still text of the string to go...
+			my $startline = $i;
+			while ($line !~ /<\/Text>$/) {
+				$i++;
+				if ($i == scalar(@file_lines)) {
+					&throw_fatal_error("Could not find end of string $chunk_key.");
+				}
+				$line = $file_lines[$i];
+				$line =~ s/\s*$//;  # Remove any nasty whitespace
+				$line =~ s/<Updated date=\"\d?\d-\D\D\D-\d\d\d\d.*\"\/>$//;
+			}
+			
+			# Map from chunk key to line
+			if (!defined($chunk_key_to_line_mapping{$chunk_key})) {
+				$chunk_key_to_line_mapping{$chunk_key} = $startline . "-" . $i;
+			}
+			else {
+				&throw_fatal_error("Duplicate key $chunk_key.");
+			}
+		}
+    }
+	
     return %chunk_key_to_line_mapping;
 }
@@ -1574,10 +1551,10 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Simple: just remove the Text tags
     $chunk_text =~ s/^\s*<Text id=\"(.*?)\">(\s*)//;
     $chunk_text =~ s/<Updated date=\"\d?\d-\D\D\D-\d\d\d\d.*\"\/>$//;
     $chunk_text =~ s/<\/Text>$//;
-
+	
     return $chunk_text;
 }
@@ -1587,10 +1564,10 @@
 {
     my ($chunk_text) = @_;
-
+	
     # Check for an "Updated DD-MMM-YYYY" comment at the end of the chunk
     if ($chunk_text =~ /<Updated date=\"(\d?\d-\D\D\D-\d\d\d\d.*)\"\/>$/i) {
-	return $1;
-    }
-
+		return $1;
+    }
+	
     return undef;
 }
